# Copyright (c) 2012-2022, Mark Peek <mark@peek.org>
# All rights reserved.
#
# See LICENSE file for full license.
#
# *** Do not modify - this file is autogenerated ***


from . import AWSObject, AWSProperty, PropsDictType, Tags


class ScheduleConfig(AWSProperty):
    """
    `ScheduleConfig <http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-appintegrations-dataintegration-scheduleconfig.html>`__
    """

    props: PropsDictType = {
        "FirstExecutionFrom": (str, True),
        "Object": (str, True),
        "ScheduleExpression": (str, True),
    }


class DataIntegration(AWSObject):
    """
    `DataIntegration <http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-appintegrations-dataintegration.html>`__
    """

    resource_type = "AWS::AppIntegrations::DataIntegration"

    props: PropsDictType = {
        "Description": (str, False),
        "KmsKey": (str, True),
        "Name": (str, True),
        "ScheduleConfig": (ScheduleConfig, True),
        "SourceURI": (str, True),
        "Tags": (Tags, False),
    }


class EventFilter(AWSProperty):
    """
    `EventFilter <http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-appintegrations-eventintegration-eventfilter.html>`__
    """

    props: PropsDictType = {
        "Source": (str, True),
    }


class EventIntegration(AWSObject):
    """
    `EventIntegration <http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-appintegrations-eventintegration.html>`__
    """

    resource_type = "AWS::AppIntegrations::EventIntegration"

    props: PropsDictType = {
        "Description": (str, False),
        "EventBridgeBus": (str, True),
        "EventFilter": (EventFilter, True),
        "Name": (str, True),
        "Tags": (Tags, False),
    }
